import pygame
from pygame.locals import *
from pygame import gfxdraw
from math import *

L = 300
FREQ = 28
R = 60
r = 15
omega = pi

noir = 0, 0, 0
blanc = 255, 255, 255
jaune = 255, 255, 0
bleu = 0, 0, 255
rouge = pygame.Color("red")
rouge_transparent = Color(255, 0, 0, 180)

## QUESTION 4

# le monde est desormais un couple (theta,signe)

monde_initial = (0,1)

def M(theta) :
    return int(L/2 + R * cos(theta)), int(L/2 + R * sin(theta))

# on prend en compte le signe dans la fonction suivant

def suivant(monde) :
    (theta,signe) = monde
    dt = 1/FREQ
    dtheta = omega * dt
    return (theta + signe * dtheta, signe)

# la fonction dessin reste tres similaire

def dessin(fenetre, monde):
    (theta, _) = monde
    fenetre.fill(pygame.Color("white"))
    dessine_cercle_en_pointilles(fenetre, (L//2,L//2), R, noir)
    dessine_disque_transparent(fenetre, M(theta), r, rouge_transparent)
                       
# on a une nouvelle fonction pour la gestion du clavier

def clavier(presse, touche, monde) :
    if presse :
        (theta,signe) = monde
        return (theta, -signe)
    return monde

# QUESTION 5

# on ajoute une fonction fin qui determine si on est arrive au monde de la fin

def fin(monde) :
    (theta, _) = monde
    return theta > 6 * pi or theta < -6 * pi

# on ajoute enfin a la boucle infinie les fonctions clavier et fin

def boucle_infinie(largeur, hauteur, freq, dessin, suivant, monde_initial, clavier, fin):
    pygame.init()
    fenetre = pygame.display.set_mode((largeur,hauteur))
    clock = pygame.time.Clock()
    monde = monde_initial
    while True:
        for ev in pygame.event.get() :
            if ev.type == QUIT :
                return
            if ev.type == KEYUP or ev.type == KEYDOWN :
                monde = clavier(ev.type == KEYDOWN, ev.key, monde)
        if fin(monde):
            return
        dessin(fenetre,monde)
        pygame.display.update()
        monde = suivant(monde)
        clock.tick(freq)

### Les fonctions auxiliaires utilisees pour obtenir la transparence et
### les pointilles

def dessine_arc(surface, center, radius, start_angle, stop_angle, color):
    x,y = center
    start_angle = int(start_angle%360)
    stop_angle = int(stop_angle%360)
    if start_angle == stop_angle:
        gfxdraw.circle(surface, x, y, radius, color)
    else:
        gfxdraw.arc(surface, x, y, radius, start_angle, stop_angle, color)

def dessine_cercle_en_pointilles(surface, center, radius, color) :
    pas = 12
    for alpha in range(360 // pas):
        dessine_arc(surface, center, radius, pas * alpha, pas * alpha + pas//2, color) 

def dessine_disque_transparent(surface, centre, rayon, couleur):
    s = pygame.Surface((2*rayon,2*rayon))
    s.fill(Color(255, 255, 255, 0))
    s.set_alpha(couleur[3])
    pygame.draw.circle(s, couleur, (rayon,rayon), rayon)
    (x,y) = centre
    surface.blit(s,(x-rayon,y-rayon))

### le lancement de l'animation

boucle_infinie(L, L, FREQ, dessin, suivant, monde_initial, clavier, fin)
