import pygame
from pygame import *

pygame.init()

fond = pygame.image.load("gazon.jpg")
perso = pygame.image.load("perso.png")

dim = (L,H) = (fond.get_width(), fond.get_height())
(l,h) = (perso.get_width(), perso.get_height())

fenetre = pygame.display.set_mode(dim)

fond = fond.convert()
perso = perso.convert_alpha()

FREQ = 28  # en images par seconde
SPEED = 30 # en pixels par seconde 
dp = SPEED / FREQ # un deplacement elementaire

## le monde est un quadruplet ((x,y),(dx,dy)) ou dx,dy est le signe
## de la vitesse de deplacement du personnage selon x et y respectivement

## au debut le perso est au milieu de la scene et ne bouge pas
monde_initial = ((L//2, H//2), (0,0))

# la fonction suivant deplace la position selon ce qui est indique par dx et dy
# on doit aussi verifier que l'on ne sort pas du cadre

def suivant(monde) :
    ((x, y), (dx, dy)) = monde
    (x2,y2) = (x + dp * dx, y + dp * dy)
    x2 = min(L-l, max(0, x2))
    y2 = min(H-h, max(0, y2))
    return ((x2, y2), (dx, dy))

## la fonction dessine place le perso a sa position

def dessine(fenetre, monde) :
    (pos, _) = monde 
    fenetre.blit(fond, (0, 0))
    fenetre.blit(perso, pos)

## la fonction clavier permet de changer le signe des deplacements
    
def clavier(presse, touche, monde) :
    (pos, (dx, dy)) = monde 
    if presse :
        if touche == K_LEFT :
            dx = -1
        if touche == K_RIGHT :
            dx = 1
        if touche == K_UP :
            dy = -1
        if touche == K_DOWN :
            dy = 1
    else :
        if touche in [K_LEFT, K_RIGHT] :
            dx = 0
        if touche in [K_UP, K_DOWN] :
            dy = 0
    return (pos, (dx, dy))

## note : on pourrait aussi avoir un monde de la forme
## ((x,y), (up,down,left,right))
## qui se souvient quelles touches de deplacement sont pressees


def fin(monde) : return False
            
# la fonction boucle_infinie, copier-coller de l'exercice 1.
# on a seulement deplace la definition de la fenetre, qu'il faut
# faire avant d'appeler convert()...



def boucle_infinie(largeur, hauteur, freq, dessine, suivant, monde_initial, clavier, fin):
    clock = pygame.time.Clock()
    monde = monde_initial
    while True:
        for ev in pygame.event.get() :
            if ev.type == QUIT :
                return
            if ev.type == KEYUP or ev.type == KEYDOWN :
                monde = clavier(ev.type == KEYDOWN, ev.key, monde)
        if fin(monde):
            return
        dessine(fenetre, monde)
        pygame.display.update()
        monde = suivant(monde)
        clock.tick(freq)


boucle_infinie(L, H, FREQ, dessine, suivant, monde_initial, clavier, fin)
