import pygame
from pygame import *

pygame.init()


dim = (L,H) = 300,300

fenetre = pygame.display.set_mode(dim)

FREQ = 28  # en images par seconde


## le monde est un couple (surface, actif, pos) où
## - surface est le dessin realise
## - actif est vrai si on est en train de dessiner
## - pos est la derniere position de la souris enregistree

def nouvelle_surface() :
    rect = fenetre.get_rect()
    surface = Surface((rect.width, rect.height))
    surface.fill(pygame.Color("white"))
    return surface

monde_initial = (nouvelle_surface(),
                 False,
                 (0,0))

def suivant(monde) :
    return monde

def dessine(fenetre, monde) :
    (surface, _, _) = monde
    fenetre.blit(surface, (0, 0))

def souris(fenetre, type, monde) :
    (surface, actif, pos) = monde
    if type == MOUSEMOTION and actif :
        pos2 = pygame.mouse.get_pos()
        pygame.draw.line(surface, pygame.Color("black"), pos, pos2)
        return (surface, actif, pos2)
    bouton_gauche = pygame.mouse.get_pressed()[0]
    bouton_droite = pygame.mouse.get_pressed()[2]
    if type == MOUSEBUTTONDOWN and bouton_droite :
        return (nouvelle_surface(), False, pos)    
    if type == MOUSEBUTTONDOWN and bouton_gauche : 
        return (surface, True, pygame.mouse.get_pos())
    if type == MOUSEBUTTONUP :
        return (surface, False, pos)
    return monde

## note : on pourrait aussi avoir un monde de la forme
## ((x,y), (up,down,left,right))
## qui se souvient quelles touches de deplacement sont pressees


def fin(monde) : return False
            
# la fonction boucle_infinie, copier-coller de l'exercice 1.
# on a seulement deplace la definition de la fenetre, qu'il faut
# faire avant d'appeler convert()...



def boucle_infinie(largeur, hauteur, freq, dessine, suivant, monde_initial, souris, fin):
    clock = pygame.time.Clock()
    monde = monde_initial
    while True:
        for ev in pygame.event.get() :
            if ev.type == QUIT :
                return
            if ev.type in [MOUSEMOTION, MOUSEBUTTONDOWN, MOUSEBUTTONUP] :
                monde = souris(fenetre, ev.type, monde) 
        if fin(monde) :
            return
        dessine(fenetre, monde)
        pygame.display.update()
        monde = suivant(monde)
        clock.tick(freq)


boucle_infinie(L, H, FREQ, dessine, suivant, monde_initial, souris, fin)
